Index: branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/iom_cdf.f90
===================================================================
--- branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/iom_cdf.f90	(revision 7148)
+++ branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/iom_cdf.f90	(revision 7153)
@@ -316,4 +316,6 @@
    !> @author J.Paul
    !> @date November, 2013 - Initial Version
+   !> @date October, 2016
+   !> - define cdf4 as cdf.
    !
    !> @param[inout] td_file   file structure
@@ -340,5 +342,6 @@
             td_file%c_type='cdf'
          CASE(nf90_format_netcdf4, nf90_format_netcdf4_classic)
-            td_file%c_type='cdf4'
+            !td_file%c_type='cdf4'
+            td_file%c_type='cdf'
       END SELECT
 
@@ -351,8 +354,10 @@
    !> reorder dimension to ('x', 'y', 'z', 't').
    !> The dimension structure inside file structure is then completed.
-   !
-   !> @author J.Paul
-   !> @date November, 2013 - Initial Version
-   !
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial Version
+   !> @date October, 2016
+   !> - check unknown dimension
+   !>
    !> @param[inout] td_file   file structure
    !-------------------------------------------------------------------
@@ -375,12 +380,14 @@
 
       IF( td_file%i_ndim > 0 )THEN
+
          ii=1
          DO ji = 1, td_file%i_ndim
             ! read dimension information
             tl_dim=iom_cdf_read_dim( td_file, ji)
-            IF( .NOT. dim_is_dummy(tl_dim) )THEN
+            ! sname == 'u' if dimension is unknown (not to be used)
+            IF( TRIM(tl_dim%c_sname) /= 'u' )THEN
                IF( ii > ip_maxdim )THEN
                   CALL logger_fatal("IOM CDF OPEN: too much dimension "//&
-                  & "to be read. you should remove dummy dimension using "//&
+                  & "to be read. you could choose dimension to be used. see "//&
                   & " configuration file")
                ENDIF
@@ -395,6 +402,6 @@
             &  " IOM CDF GET FILE DIM: there is no unlimited dimension in file "//&
             &  TRIM(td_file%c_name))
-         ELSE
-            td_file%t_dim( td_file%i_uldid )%l_uld=.TRUE.
+         !ELSE
+         !   td_file%t_dim( td_file%i_uldid )%l_uld=.TRUE.
          ENDIF
 
@@ -466,5 +473,5 @@
    !> The variable structure inside file structure is then completed.
    !> @note variable value are not read !
-   !
+   !>
    !> @author J.Paul
    !> @date November, 2013 - Initial Version
@@ -473,5 +480,8 @@
    !> @date January, 2016
    !> - increment n3d for 4D variable
-   !
+   !> @date October, 2016
+   !> - check if variable to be used (variable's dimension allowed and variable
+   !> not "dummy")
+   !>
    !> @param[inout] td_file   file structure
    !-------------------------------------------------------------------
@@ -501,15 +511,11 @@
          il_nvar=td_file%i_nvar
          ALLOCATE(tl_var(il_nvar))
-         ii=0
          DO ji = 1, il_nvar
            ! read variable information
            tl_var(ji)=iom_cdf__read_var_meta( td_file, ji) 
-           IF( .NOT. var_is_dummy(tl_var(ji)) )THEN
-              ii=ii+1
-           ENDIF
          ENDDO
 
          ! update number of variable used
-         td_file%i_nvar=ii
+         td_file%i_nvar=COUNT(tl_var(:)%l_use)
 
          ALLOCATE(td_file%t_var(td_file%i_nvar))
@@ -517,5 +523,5 @@
          ii=0
          DO ji = 1, il_nvar
-            IF( .NOT. var_is_dummy(tl_var(ji)) )THEN
+            IF( tl_var(ji)%l_use )THEN
                ii=ii+1
                td_file%t_var(ii)=var_copy(tl_var(ji))
@@ -552,4 +558,11 @@
                      td_file%i_timeid=ji
                   ELSE
+                     IF( td_file%i_timeid /= ji )THEN
+                        CALL logger_warn("IOM CDF GET FILE VAR: find more "//&
+                        &                 "than one time variable in file "//&
+                        &                 TRIM(td_file%c_name)//". see "//&
+                        &                 "dummy.cfg configuration file to"//&
+                        &                 " not used dummy variables.")
+                     ENDIF
                      il_attid=0
                      IF( ASSOCIATED(td_file%t_var(ii)%t_att) )THEN
@@ -558,8 +571,4 @@
                      IF( il_attid /= 0 )THEN
                         td_file%i_timeid=ji
-                     !ELSE
-                     !   CALL logger_error("IOM CDF GET FILE VAR: find more "//&
-                     !   &                 "than one time variable in file "//&
-                     !   &                 TRIM(td_file%c_name) )
                      ENDIF
                   ENDIF
@@ -1413,4 +1422,16 @@
          ENDDO
 
+         !! check if variable is dummy
+         IF( var_is_dummy(iom_cdf__read_var_meta) )THEN
+            iom_cdf__read_var_meta%l_use=.FALSE.
+         ENDIF
+
+         !! check if all dimensions are allowed
+         DO ji=1,il_ndim
+            IF( ALL(td_file%t_dim(:)%i_id /= il_dimid(ji)) )THEN
+               iom_cdf__read_var_meta%l_use=.FALSE.
+            ENDIF
+         ENDDO
+
          ! clean
          CALL dim_clean(tl_dim(:))
@@ -1461,5 +1482,6 @@
 
       ! local variable
-      INTEGER(i4), DIMENSION(ip_maxdim) :: il_xyzt2
+      INTEGER(i4), DIMENSION(1) :: il_ind
+      INTEGER(i4) :: il_xyzt2
 
       TYPE(TDIM) , DIMENSION(ip_maxdim) :: tl_dim
@@ -1484,9 +1506,8 @@
       ELSE IF( id_ndim > 0 )THEN
 
-
          ii=1
          DO ji = 1, id_ndim
 
-            !!! check no dummy dimension to be used
+            ! check if dimension to be used, is allowed
             IF( ANY(td_file%t_dim(:)%i_id == id_dimid(ji)) )THEN
                IF( ii > ip_maxdim )THEN
@@ -1499,10 +1520,12 @@
                   &  "dimension "//TRIM(fct_str(ji)) )
 
-               il_xyzt2(ii)=td_file%t_dim(id_dimid(ji))%i_xyzt2
+               il_ind(:)= MINLOC(td_file%t_dim(:)%i_id, &
+                        &        td_file%t_dim(:)%i_id==id_dimid(ji) )
+               il_xyzt2 = td_file%t_dim(il_ind(1))%i_xyzt2
 
                ! read dimension information
-               tl_dim(ii) = dim_init( td_file%t_dim(il_xyzt2(ii))%c_name, &
-               &                      td_file%t_dim(il_xyzt2(ii))%i_len )
-            
+               tl_dim(ii) = dim_init( td_file%t_dim(il_xyzt2)%c_name, &
+               &                      td_file%t_dim(il_xyzt2)%i_len )
+
                ii=ii+1
             ELSE
Index: branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/merge_bathy.f90
===================================================================
--- branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/merge_bathy.f90	(revision 7148)
+++ branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/merge_bathy.f90	(revision 7153)
@@ -51,4 +51,6 @@
 !>       - cn_varcfg : variable configuration file 
 !> (see ./SIREN/cfg/variable.cfg)
+!>       - cn_dimcfg : dimension configuration file. define dimension allowed to
+!> be used (see ./SIREN/cfg/dimension.cfg).
 !>       - cn_dumcfg : useless (dummy) configuration file, for useless 
 !> dimension or variable (see ./SIREN/cfg/dummy.cfg).
@@ -133,4 +135,5 @@
 !> @date October, 2016
 !> - allow to choose the number of boundary point with coarse grid value.
+!> - dimension to be used select from configuration file
 !>
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -211,6 +214,7 @@
 
    ! namcfg
-   CHARACTER(LEN=lc)                       :: cn_varcfg = 'variable.cfg' 
-   CHARACTER(LEN=lc)                       :: cn_dumcfg = 'dummy.cfg'
+   CHARACTER(LEN=lc)                       :: cn_varcfg = './cfg/variable.cfg' 
+   CHARACTER(LEN=lc)                       :: cn_dimcfg = './cfg/dimension.cfg'
+   CHARACTER(LEN=lc)                       :: cn_dumcfg = './cfg/dummy.cfg'
 
    ! namcrs
@@ -252,4 +256,5 @@
    NAMELIST /namcfg/ &  !< config namelist
    &  cn_varcfg, &       !< variable configuration file
+   &  cn_dimcfg, &       !< dimension configuration file
    &  cn_dumcfg          !< dummy configuration file
 
@@ -324,4 +329,7 @@
       CALL var_def_extra(TRIM(cn_varcfg))
 
+      ! get dimension allowed
+      CALL dim_def_extra(TRIM(cn_dimcfg))
+
       ! get dummy variable
       CALL var_get_dummy(TRIM(cn_dumcfg))
@@ -626,4 +634,5 @@
    DEALLOCATE(dl_weight)
    CALL boundary_clean(tl_bdy(:))
+   CALL var_clean_extra()
 
    ! close log file
@@ -850,5 +859,5 @@
                il_width=td_bdy%t_seg(jl)%i_width-id_ncrs
                ! compute "distance"
-               dl_tmp1d(:)=(/(ji,ji=il_width-1,1,-1),(0,ji=1,id_ncrs)/)
+               dl_tmp1d(:)=(/(ji,ji=il_width,1,-1),(0,ji=1,id_ncrs)/)
 
                ! compute weight on segment
@@ -869,5 +878,5 @@
                il_width=td_bdy%t_seg(jl)%i_width-id_ncrs
                ! compute "distance"
-               dl_tmp1d(:)=(/(0,ji=1,id_ncrs),(ji,ji=1,il_width-1)/)
+               dl_tmp1d(:)=(/(0,ji=1,id_ncrs),(ji,ji=1,il_width)/)
 
                ! compute weight on segment
@@ -888,5 +897,5 @@
                il_width=td_bdy%t_seg(jl)%i_width-id_ncrs
                ! compute "distance"
-               dl_tmp1d(:)=(/(ji,ji=il_width-1,1,-1),(0,ji=1,id_ncrs)/)
+               dl_tmp1d(:)=(/(ji,ji=il_width,1,-1),(0,ji=1,id_ncrs)/)
 
                ! compute weight on segment
@@ -907,5 +916,5 @@
                il_width=td_bdy%t_seg(jl)%i_width-id_ncrs
                ! compute "distance"
-               dl_tmp1d(:)=(/(0,ji=1,id_ncrs),(ji,ji=1,il_width-1)/)
+               dl_tmp1d(:)=(/(0,ji=1,id_ncrs),(ji,ji=1,il_width)/)
 
                ! compute weight on segment
Index: branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/variable.f90
===================================================================
--- branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 7148)
+++ branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 7153)
@@ -34,5 +34,5 @@
 !>    Note:<br/>
 !>       - others optionals arguments could be added, see var_init.
-!>       - to put variable 0D, use td_dim with all dimension unused
+!>       - to put scalar variable (OD), use td_dim with all dimension unused
 !> (td_dim(:)%l_use=.FALSE.)
 !>    
@@ -267,4 +267,9 @@
 !>    - cd_varinfo is variable information from namelist
 !>
+!>    to clean global array of variable structure:<br/>
+!>@code
+!>    CALL var_clean_extra( )
+!>@endcode
+!>
 !>    to check variable dimension expected, as defined in file 'variable.cfg':<br/>
 !>@code
@@ -287,5 +292,8 @@
 !> @date Spetember, 2015
 !> - manage useless (dummy) variable
-!
+!> @date October, 2016
+!> - add subroutine to clean global array of extra information.
+!> - define logical for variable to be used
+!>
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
 !----------------------------------------------------------------------
@@ -337,4 +345,5 @@
    PUBLIC :: var_def_extra     !< read variable configuration file, and save extra information.
    PUBLIC :: var_chg_extra     !< read variable namelist information, and modify extra information.
+   PUBLIC :: var_clean_extra   !< clean gloabl array of extra information.
    PUBLIC :: var_check_dim     !< check variable dimension expected
    PUBLIC :: var_get_dummy     !< fill dummy variable array
@@ -416,5 +425,6 @@
       TYPE(TDIM), DIMENSION(ip_maxdim)  :: t_dim           !< variable dimension
  
-      LOGICAL           :: l_file = .FALSE.  !< variable read in a file
+      LOGICAL           :: l_file = .FALSE. !< variable read in a file
+      LOGICAL           :: l_use  = .TRUE.  !< variable to be used
 
       ! highlight some attributes
@@ -451,5 +461,5 @@
                                                         !< fill when running var_def_extra() 
 
-   CHARACTER(LEN=lc), DIMENSION(ip_maxdum), SAVE :: cm_dumvar !< dummy variable
+   CHARACTER(LEN=lc), DIMENSION(ip_maxdumcfg), SAVE :: cm_dumvar !< dummy variable
 
    INTERFACE var_init
@@ -593,4 +603,7 @@
          CALL att_clean(tl_att)
       ENDIF
+
+      var__copy_unit%l_file     = td_var%l_file
+      var__copy_unit%l_use      = td_var%l_use
 
       ! copy highlight attribute
@@ -6669,4 +6682,5 @@
       ! check if variable is in array of variable structure
       DO ji=1,il_size
+
          ! look for variable name
          IF( fct_lower(td_var(ji)%c_name) == fct_lower(cd_name) )THEN
@@ -6683,4 +6697,5 @@
 
          ELSE IF( PRESENT(cd_stdname) )THEN 
+
             IF( fct_lower(td_var(ji)%c_stdname) == fct_lower(cd_stdname) .AND.&
             &    TRIM(fct_lower(td_var(ji)%c_stdname)) /= '' )THEN
@@ -6690,10 +6705,21 @@
             ENDIF
 
+         ENDIF
+
          ! look for variable longname
-         ELSE IF( fct_lower(td_var(ji)%c_longname) == fct_lower(cd_name) .AND.&
-         &    TRIM(fct_lower(td_var(ji)%c_longname)) /= '' )THEN
+         IF( fct_lower(td_var(ji)%c_longname) == fct_lower(cd_name) .AND.&
+         &   TRIM(fct_lower(td_var(ji)%c_longname)) /= '' )THEN
             
             var_get_index=ji
             EXIT
+
+         ELSE IF( PRESENT(cd_stdname) )THEN
+
+            IF( fct_lower(td_var(ji)%c_longname) == fct_lower(cd_stdname) .AND.&
+            &    TRIM(fct_lower(td_var(ji)%c_longname)) /= '' )THEN
+            
+               var_get_index=ji
+               EXIT
+            ENDIF
 
          ENDIF
@@ -6734,4 +6760,5 @@
       ! check if variable is in array of variable structure
       DO ji=1,il_size
+      
          ! look for variable name
          IF( fct_lower(td_var(ji)%c_name) == fct_lower(cd_name) )THEN
@@ -6747,12 +6774,6 @@
             EXIT
 
-         ! look for variable long name
-         ELSE IF( fct_lower(td_var(ji)%c_longname) == fct_lower(cd_name) .AND.&
-         &    TRIM(fct_lower(td_var(ji)%c_longname)) /= '' )THEN
-            
-            var_get_id=td_var(ji)%i_id
-            EXIT
-
-         ELSE IF( PRESENT(cd_stdname) )THEN 
+         ELSE IF( PRESENT(cd_stdname) )THEN
+
             IF( fct_lower(td_var(ji)%c_stdname) == fct_lower(cd_stdname) .AND.&
             &    TRIM(fct_lower(td_var(ji)%c_stdname)) /= '' )THEN
@@ -6761,4 +6782,23 @@
                EXIT
             ENDIF
+
+         ENDIF
+
+         ! look for variable long name
+         IF( fct_lower(td_var(ji)%c_longname) == fct_lower(cd_name) .AND.&
+         &    TRIM(fct_lower(td_var(ji)%c_longname)) /= '' )THEN
+            
+            var_get_id=td_var(ji)%i_id
+            EXIT
+
+         ELSE IF( PRESENT(cd_stdname) )THEN 
+
+            IF( fct_lower(td_var(ji)%c_longname) == fct_lower(cd_stdname) .AND.&
+            &    TRIM(fct_lower(td_var(ji)%c_longname)) /= '' )THEN
+            
+               var_get_id=td_var(ji)%i_id
+               EXIT
+            ENDIF
+
          ENDIF
 
@@ -7176,4 +7216,21 @@
    !-------------------------------------------------------------------
    !> @brief
+   !> This subroutine clean global array of variable structure 
+   !> with extra information: tg_varextra.
+   !> 
+   !> @author J.Paul
+   !> @date October, 2016 - Initial Version
+   !-------------------------------------------------------------------
+   SUBROUTINE var_clean_extra( )
+      IMPLICIT NONE
+      ! Argument
+      !----------------------------------------------------------------
+
+      CALL var_clean(tg_varextra(:))
+      DEALLOCATE(tg_varextra)
+
+   END SUBROUTINE var_clean_extra
+   !-------------------------------------------------------------------
+   !> @brief
    !> This subroutine read matrix value from character string in namelist
    !> and fill variable strucutre value.
@@ -8463,7 +8520,7 @@
       ! loop indices
       ! namelist
-      CHARACTER(LEN=lc), DIMENSION(ip_maxdum) :: cn_dumvar
-      CHARACTER(LEN=lc), DIMENSION(ip_maxdum) :: cn_dumdim
-      CHARACTER(LEN=lc), DIMENSION(ip_maxdum) :: cn_dumatt
+      CHARACTER(LEN=lc), DIMENSION(ip_maxdumcfg) :: cn_dumvar
+      CHARACTER(LEN=lc), DIMENSION(ip_maxdumcfg) :: cn_dumdim
+      CHARACTER(LEN=lc), DIMENSION(ip_maxdumcfg) :: cn_dumatt
 
       !----------------------------------------------------------------
@@ -8526,5 +8583,5 @@
 
       var_is_dummy=.FALSE.
-      DO ji=1,ip_maxdum
+      DO ji=1,ip_maxdumcfg
          IF( fct_lower(td_var%c_name) == fct_lower(cm_dumvar(ji)) )THEN
             var_is_dummy=.TRUE.
